// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#pragma once
#include <stdlib.h>
#include <string>
#include <vector>

#include "cfg.h"
#include "view.h"
#include "source.h"
#include "target.h"

class view_ss : public view
{
private:
	const bool auto_shrink;

protected:
	const double switch_interval;
	std::vector<target *> *const targets;
	uint8_t *prev_frame { nullptr };

	size_t cur_source_index;
	uint64_t latest_switch;
	source *cur_source;

public:
	view_ss(configuration_t *const cfg, const std::string & id, const std::string & descr, const int width, const int height, const bool auto_shrink, resize *const r, const std::vector<view_src_t> & sources, const double switch_interval, std::vector<target *> *const targets, std::vector<filter *> *const filters);
	virtual ~view_ss();

	std::string get_html(const std::map<std::string, std::string> & pars) const override;
	bool get_frame(const encoding_t pe, const int jpeg_quality, uint64_t *ts, int *width, int *height, uint8_t **frame, size_t *frame_len, const bool repeat) override;
	virtual source *get_current_source() override;

	void register_user() override;
	void unregister_user() override;

	void stop() override;
	virtual void operator()() override;
};
